#ifndef ESP32_STORAGE_HPP
#define ESP32_STORAGE_HPP

#ifdef ESP32
#include "Preferences.h"
#elif defined(ESP8266)
#include "EEPROM.h"
#endif

#include "Utils.hpp"

namespace fw
{
    class Storage
    {
    public:
        Storage();
        ~Storage();

    private:
#ifdef ESP32
        Preferences memory;
#elif defined(ESP8266)
        uint8_t max_rules;
        uint16_t eeprom_size;
        uint16_t eeprom_amount_of_rules;
        uint16_t eeprom_rules_head;

#endif
        uint16_t eeprom_rule_position(uint8_t key);

    protected:
        uint8_t retrieve_amount_of_rules();
        void store_amount_of_rules(const uint8_t new_amount);
        firewall_rule_t *retrieve_firewall_rule(const uint8_t key);
        void store_all_firewall_rules(firewall_rule_t *rule_head);
        void store_firewall_rule(firewall_rule_t *rule_ptr);
    };
}

#endif
